aboutsummaryrefslogtreecommitdiff
path: root/share
diff options
context:
space:
mode:
authorSilvio Rhatto <rhatto@riseup.net>2012-06-27 17:54:25 -0300
committerSilvio Rhatto <rhatto@riseup.net>2012-06-27 17:54:25 -0300
commit28b0d717d26c5878bd0c432fe6cd91a45ea566da (patch)
tree7682fed16e25273029a691c402d714872e9789a5 /share
parentf5459b2c4d0781f2ee7c1f0d985aa687413de914 (diff)
downloadhydra-28b0d717d26c5878bd0c432fe6cd91a45ea566da.tar.gz
hydra-28b0d717d26c5878bd0c432fe6cd91a45ea566da.tar.bz2
Adding backup-restore-email
Diffstat (limited to 'share')
-rwxr-xr-xshare/hydractl/backup-restore-email72
-rwxr-xr-xshare/hydractl/backup-restore-hidden3
2 files changed, 74 insertions, 1 deletions
diff --git a/share/hydractl/backup-restore-email b/share/hydractl/backup-restore-email
new file mode 100755
index 0000000..f0d7979
--- /dev/null
+++ b/share/hydractl/backup-restore-email
@@ -0,0 +1,72 @@
+#!/bin/bash
+#
+# Email backup restoration.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as
+# published by the Free Software Foundation, either version 3 of the
+# License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public
+# License along with this program. If not, see
+# <http://www.gnu.org/licenses/>.
+
+# Load.
+source $APP_BASE/lib/hydra/functions || exit 1
+hydra_config_load
+
+# Parameters.
+DATE="`date +%Y%m%d`"
+EMAIL_DIR="/var/mail/virtual"
+
+# Check restore strategy.
+if [ "$1" == "localhost" ] || [ "$1" == "`facter hostname`" ]; then
+ hydra_backup_environment_local
+else
+ hydra_backup_environment_remote $1 restore
+fi
+
+# Check if folder exist on the backup.
+if [ ! -d "$RESTOREDIR/$EMAIL_DIR" ]; then
+ echo "Email folder does not exist: $RESTOREDIR/$EMAIL_DIR"
+ exit 1
+fi
+
+# Set git user.
+if hydra_check_user vmail; then
+ EMAIL_USER="vmail"
+else
+ EMAIL_USER="root"
+fi
+
+# Set git group.
+if hydra_check_group vmail; then
+ EMAIL_GROUP="vmail"
+else
+ EMAIL_GROUP="root"
+fi
+
+# TODO: Backup it?
+#hydractl backup-email
+
+# Restore email folder from backup.
+#
+# Symlink creation on site instances like drupal should be done
+# already by backup-restore-site.
+for folder in `ls $RESTOREDIR/$EMAIL_DIR`; do
+ if [ -d "$EMAIL_DIR/$folder" ]; then
+ echo "Email for user $email already exists on $EMAIL_DIR/$folder!"
+ else
+ echo "Processing $EMAIL_DIR/$folder..."
+ cp -a $RESTOREDIR/$EMAIL_DIR/$folder $EMAIL_DIR/$folder
+ fi
+done
+
+# Fix permissions.
+chown -R $EMAIL_USER.$EMAIL_GROUP $EMAIL_DIR
+
diff --git a/share/hydractl/backup-restore-hidden b/share/hydractl/backup-restore-hidden
index 24cd9bf..4e2ba2a 100755
--- a/share/hydractl/backup-restore-hidden
+++ b/share/hydractl/backup-restore-hidden
@@ -63,12 +63,13 @@ for folder in `ls $RESTOREDIR/$HIDDEN_DIR`; do
# A hidden service already exists
if ! diff "$HIDDEN_DIR/$folder/hostname" "$RESTOREDIR/$HIDDEN_DIR/$folder/hostname" &> /dev/null; then
# They're different hidden services!
- echo "Hidden service $hidden already exist on $HIDDEN_DIR/$folder and differs from backup!"
+ echo "Hidden service $hidden already exists on $HIDDEN_DIR/$folder and differs from backup!"
echo "Please fix this conflict manually and restore backups again."
else
echo "Hidden service $hidden already in place, no need to copy."
fi
else
+ echo "Processing $HIDDEN_DIR/$folder..."
rm -rf $HIDDEN_DIR/$folder
cp -a $RESTOREDIR/$HIDDEN_DIR/$folder $HIDDEN_DIR/$folder
fi